diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/utils.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/utils.py
new file mode 100644
index 000000000..2d6e3ad09
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/check_constraint/utils.py
@@ -0,0 +1,177 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2019, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+""" Implements Utility class for Check Constraint. """
+
+from flask import render_template
+from flask_babelex import gettext as _
+from pgadmin.utils.ajax import internal_server_error
+from pgadmin.utils.exception import ObjectGone
+from functools import wraps
+
+
+def get_template_path(f):
+    """
+    This function will behave as a decorator which will prepare
+    the template path based on database server version.
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold the connection object
+        conn_obj = args[0]
+        template_path = ''
+        if 'template_path' not in kwargs:
+            template_path = 'check_constraint/sql/#{0}#'.format(
+                conn_obj.manager.version)
+        else:
+            template_path = kwargs['template_path']
+
+        return f(*args, **kwargs, template_path=template_path)
+    return wrap
+
+
+@get_template_path
+def get_parent(conn, tid, template_path=None):
+    """
+    This function will return the parent of the given table.
+    :param conn: Connection Object
+    :param tid: Table oid
+    :param template_path:
+    :return:
+    """
+
+    SQL = render_template("/".join([template_path,
+                                    'get_parent.sql']), tid=tid)
+    status, rset = conn.execute_2darray(SQL)
+    if not status:
+        raise Exception(rset)
+
+    schema = ''
+    table = ''
+    if 'rows' in rset and len(rset['rows']) > 0:
+        schema = rset['rows'][0]['schema']
+        table = rset['rows'][0]['table']
+
+    return schema, table
+
+
+@get_template_path
+def get_check_constraints(conn, tid, cid=None, template_path=None):
+    """
+    This function is used to fetch information of the
+    check constraint(s) for the given table.
+    :param conn: Connection Object
+    :param tid: Table ID
+    :param cid: Check Constraint ID
+    :param template_path: Template Path
+    :return:
+    """
+
+    sql = render_template("/".join(
+        [template_path, 'properties.sql']), tid=tid, cid=cid)
+
+    status, result = conn.execute_dict(sql)
+    if not status:
+        return status, internal_server_error(errormsg=result)
+
+    return True, result['rows']
+
+
+@get_template_path
+def get_check_constraint_sql(conn, tid, data, template_path=None):
+    """
+    This function will return sql for check constraints.
+    :param conn: Connection Object
+    :param tid: Table ID
+    :param data: Data
+    :param template_path: Template Path
+    :return:
+    """
+
+    sql = []
+    # Check if constraint is in data
+    # If yes then we need to check for add/change/delete
+    if 'check_constraint' in data:
+        constraint = data['check_constraint']
+        # If constraint(s) is/are deleted
+        if 'deleted' in constraint:
+            for c in constraint['deleted']:
+                c['schema'] = data['schema']
+                c['table'] = data['name']
+
+                # Sql for drop
+                sql.append(
+                    render_template("/".join(
+                        [template_path, 'delete.sql']),
+                        data=c, conn=conn).strip("\n")
+                )
+
+        if 'changed' in constraint:
+            for c in constraint['changed']:
+                c['schema'] = data['schema']
+                c['table'] = data['name']
+
+                modified_sql, name = get_sql(conn, c, tid, c['oid'])
+                sql.append(modified_sql.strip('\n'))
+
+        if 'added' in constraint:
+            for c in constraint['added']:
+                c['schema'] = data['schema']
+                c['table'] = data['name']
+
+                add_sql, name = get_sql(conn, c, tid)
+                sql.append(add_sql.strip("\n"))
+
+    if len(sql) > 0:
+        # Join all the sql(s) as single string
+        return '\n\n'.join(sql)
+    else:
+        return None
+
+
+@get_template_path
+def get_sql(conn, data, tid, cid=None, template_path=None):
+    """
+    This function will generate sql from model data.
+    :param conn: Connection Object
+    :param data: data
+    :param tid: Table id
+    :param cid: Check Constraint ID
+    :param template_path: Template Path
+    :return:
+    """
+    name = data['name'] if 'name' in data else None
+    if cid is not None:
+        sql = render_template("/".join([template_path, 'properties.sql']),
+                              tid=tid, cid=cid)
+        status, res = conn.execute_dict(sql)
+        if not status:
+            raise Exception(res)
+
+        if len(res['rows']) == 0:
+            raise ObjectGone(
+                _('Could not find the check constraint in the table.'))
+
+        old_data = res['rows'][0]
+        if 'name' not in data:
+            name = data['name'] = old_data['name']
+
+        sql = render_template("/".join([template_path, 'update.sql']),
+                              data=data, o_data=old_data, conn=conn)
+    else:
+        if 'consrc' not in data:
+            return _('-- definition incomplete'), name
+        elif isinstance(data['consrc'], list) and len(data['consrc']) < 1:
+            return _('-- definition incomplete'), name
+
+        sql = render_template("/".join([template_path, 'create.sql']),
+                              data=data)
+
+    return sql, name
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/exclusion_constraint/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/exclusion_constraint/__init__.py
index c08e6ef65..fae9362c2 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/exclusion_constraint/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/exclusion_constraint/__init__.py
@@ -13,6 +13,8 @@ import simplejson as json
 from functools import wraps
 
 import pgadmin.browser.server_groups.servers.databases as database
+import pgadmin.browser.server_groups.servers.databases.schemas.tables.\
+    constraints.exclusion_constraint.utils as exclusion_utils
 from flask import render_template, make_response, request, jsonify
 from flask_babelex import gettext as _
 from pgadmin.browser.server_groups.servers.databases.schemas.tables.\
@@ -23,6 +25,7 @@ from pgadmin.utils.ajax import make_json_response, internal_server_error, \
 from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 from pgadmin.utils import IS_PY2
+
 # If we are in Python3
 if not IS_PY2:
     unicode = str
@@ -228,16 +231,10 @@ class ExclusionConstraintView(PGChildNodeView):
                 self.manager.version)
 
             # We need parent's name eg table name and schema name
-            SQL = render_template("/".join([self.template_path,
-                                            'get_parent.sql']),
-                                  tid=kwargs['tid'])
-            status, rset = self.conn.execute_2darray(SQL)
-            if not status:
-                return internal_server_error(errormsg=rset)
-
-            for row in rset['rows']:
-                self.schema = row['schema']
-                self.table = row['table']
+            schema, table = exclusion_utils.get_parent(self.conn,
+                                                       kwargs['tid'])
+            self.schema = schema
+            self.table = table
 
             return f(*args, **kwargs)
         return wrap
@@ -265,60 +262,19 @@ class ExclusionConstraintView(PGChildNodeView):
         Returns:
 
         """
-        sql = render_template("/".join([self.template_path, 'properties.sql']),
-                              did=did, tid=tid, cid=exid)
-
-        status, res = self.conn.execute_dict(sql)
-
+        status, res = exclusion_utils.get_exclusion_constraints(
+            self.conn, did, tid, exid)
         if not status:
-            return internal_server_error(errormsg=res)
+            return res
 
-        if len(res['rows']) == 0:
+        if len(res) == 0:
             return gone(_(
                 """Could not find the exclusion constraint in the table."""
             ))
 
-        result = res['rows'][0]
-
-        sql = render_template(
-            "/".join([self.template_path, 'get_constraint_cols.sql']),
-            cid=exid,
-            colcnt=result['col_count'])
-        status, res = self.conn.execute_dict(sql)
-
-        if not status:
-            return internal_server_error(errormsg=res)
-
-        columns = []
-        for row in res['rows']:
-            if row['options'] & 1:
-                order = False
-                nulls_order = True if (row['options'] & 2) else False
-            else:
-                order = True
-                nulls_order = True if (row['options'] & 2) else False
-
-            columns.append({"column": row['coldef'].strip('"'),
-                            "oper_class": row['opcname'],
-                            "order": order,
-                            "nulls_order": nulls_order,
-                            "operator": row['oprname'],
-                            "col_type": row['datatype']
-                            })
-
-        result['columns'] = columns
-
-        # Add Include details of the index supported for PG-11+
-        if self.manager.version >= 110000:
-            sql = render_template(
-                "/".join([self.template_path, 'get_constraint_include.sql']),
-                cid=exid)
-            status, res = self.conn.execute_dict(sql)
-
-            if not status:
-                return internal_server_error(errormsg=res)
-
-            result['include'] = [col['colname'] for col in res['rows']]
+        result = res
+        if exid:
+            result = res[0]
 
         return ajax_response(
             response=result,
@@ -374,16 +330,9 @@ class ExclusionConstraintView(PGChildNodeView):
             self.manager.version)
 
         # We need parent's name eg table name and schema name
-        SQL = render_template("/".join([self.template_path,
-                                        'get_parent.sql']),
-                              tid=tid)
-        status, rset = self.conn.execute_2darray(SQL)
-        if not status:
-            return internal_server_error(errormsg=rset)
-
-        for row in rset['rows']:
-            self.schema = row['schema']
-            self.table = row['table']
+        schema, table = exclusion_utils.get_parent(self.conn, tid)
+        self.schema = schema
+        self.table = table
 
         SQL = render_template("/".join([self.template_path,
                                         'properties.sql']),
@@ -489,16 +438,9 @@ class ExclusionConstraintView(PGChildNodeView):
             self.manager.version)
 
         # We need parent's name eg table name and schema name
-        SQL = render_template("/".join([self.template_path,
-                                        'get_parent.sql']),
-                              tid=tid)
-        status, rset = self.conn.execute_2darray(SQL)
-        if not status:
-            return internal_server_error(errormsg=rset)
-
-        for row in rset['rows']:
-            self.schema = row['schema']
-            self.table = row['table']
+        schema, table = exclusion_utils.get_parent(self.conn, tid)
+        self.schema = schema
+        self.table = table
 
         res = []
         SQL = render_template("/".join([self.template_path,
@@ -656,7 +598,8 @@ class ExclusionConstraintView(PGChildNodeView):
         try:
             data['schema'] = self.schema
             data['table'] = self.table
-            sql, name = self.get_sql(data, did, tid, exid)
+            sql, name = \
+                exclusion_utils.get_sql(self.conn, data, did, tid, exid)
             if not isinstance(sql, (str, unicode)):
                 return sql
             sql = sql.strip('\n').strip(' ')
@@ -787,7 +730,8 @@ class ExclusionConstraintView(PGChildNodeView):
         data['schema'] = self.schema
         data['table'] = self.table
         try:
-            sql, name = self.get_sql(data, did, tid, exid)
+            sql, name = \
+                exclusion_utils.get_sql(self.conn, data, did, tid, exid)
             if not isinstance(sql, (str, unicode)):
                 return sql
             sql = sql.strip('\n').strip(' ')
@@ -801,53 +745,6 @@ class ExclusionConstraintView(PGChildNodeView):
         except Exception as e:
             return internal_server_error(errormsg=str(e))
 
-    def get_sql(self, data, did, tid, exid=None):
-        """
-        This function will generate sql from model data.
-
-        Args:
-          data: Contains the data of the selected Exclusion constraint.
-          tid: Table ID.
-          exid: Exclusion constraint ID
-
-        Returns:
-
-        """
-        if exid is not None:
-            sql = render_template(
-                "/".join([self.template_path, 'properties.sql']),
-                did=did,
-                tid=tid,
-                cid=exid
-            )
-            status, res = self.conn.execute_dict(sql)
-            if not status:
-                return internal_server_error(errormsg=res)
-            if len(res['rows']) == 0:
-                return gone(_("Could not find the exclusion constraint."))
-
-            old_data = res['rows'][0]
-            required_args = ['name']
-            for arg in required_args:
-                if arg not in data:
-                    data[arg] = old_data[arg]
-
-            sql = render_template("/".join([self.template_path, 'update.sql']),
-                                  data=data, o_data=old_data)
-        else:
-            required_args = ['columns']
-
-            for arg in required_args:
-                if arg not in data:
-                    return _('-- definition incomplete')
-                elif isinstance(data[arg], list) and len(data[arg]) < 1:
-                    return _('-- definition incomplete')
-
-            sql = render_template("/".join([self.template_path, 'create.sql']),
-                                  data=data, conn=self.conn)
-
-        return sql, data['name']
-
     @check_precondition
     def sql(self, gid, sid, did, scid, tid, exid=None):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/exclusion_constraint/utils.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/exclusion_constraint/utils.py
new file mode 100644
index 000000000..3baad9c47
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/exclusion_constraint/utils.py
@@ -0,0 +1,218 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2019, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+""" Implements Utility class for Exclusion Constraint. """
+
+from flask import render_template
+from flask_babelex import gettext as _
+from pgadmin.utils.ajax import internal_server_error
+from pgadmin.utils.exception import ObjectGone
+from functools import wraps
+
+
+def get_template_path(f):
+    """
+    This function will behave as a decorator which will prepare
+    the template path based on database server version.
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold the connection object
+        conn_obj = args[0]
+        template_path = ''
+        if 'template_path' not in kwargs:
+            template_path = 'exclusion_constraint/sql/#{0}#'.format(
+                conn_obj.manager.version)
+        else:
+            template_path = kwargs['template_path']
+
+        return f(*args, **kwargs, template_path=template_path)
+    return wrap
+
+
+@get_template_path
+def get_parent(conn, tid, template_path=None):
+    """
+    This function will return the parent of the given table.
+    :param conn: Connection Object
+    :param tid: Table oid
+    :param template_path:
+    :return:
+    """
+
+    SQL = render_template("/".join([template_path,
+                                    'get_parent.sql']), tid=tid)
+    status, rset = conn.execute_2darray(SQL)
+    if not status:
+        raise Exception(rset)
+
+    schema = ''
+    table = ''
+    if 'rows' in rset and len(rset['rows']) > 0:
+        schema = rset['rows'][0]['schema']
+        table = rset['rows'][0]['table']
+
+    return schema, table
+
+
+@get_template_path
+def get_exclusion_constraints(conn, did, tid, exid=None, template_path=None):
+    """
+    This function is used to fetch information of the
+    exclusion constraint(s) for the given table.
+    :param conn: Connection Object
+    :param did: Database ID
+    :param tid: Table ID
+    :param exid: Exclusion Constraint ID
+    :param template_path: Template Path
+    :return:
+    """
+    sql = render_template("/".join([template_path, 'properties.sql']),
+                          did=did, tid=tid, cid=exid)
+
+    status, result = conn.execute_dict(sql)
+    if not status:
+        return status, internal_server_error(errormsg=result)
+
+    for ex in result['rows']:
+        sql = render_template("/".join([template_path,
+                                        'get_constraint_cols.sql']),
+                              cid=ex['oid'], colcnt=ex['col_count'])
+
+        status, res = conn.execute_dict(sql)
+        if not status:
+            return status, internal_server_error(errormsg=res)
+
+        columns = []
+        for row in res['rows']:
+            if row['options'] & 1:
+                order = False
+                nulls_order = True if (row['options'] & 2) else False
+            else:
+                order = True
+                nulls_order = True if (row['options'] & 2) else False
+
+            columns.append({"column": row['coldef'].strip('"'),
+                            "oper_class": row['opcname'],
+                            "order": order,
+                            "nulls_order": nulls_order,
+                            "operator": row['oprname'],
+                            "col_type": row['datatype']
+                            })
+
+        ex['columns'] = columns
+
+        # INCLUDE clause in index is supported from PG-11+
+        if conn.manager.version >= 110000:
+            sql = render_template("/".join([template_path,
+                                            'get_constraint_include.sql']),
+                                  cid=ex['oid'])
+            status, res = conn.execute_dict(sql)
+            if not status:
+                return status, internal_server_error(errormsg=res)
+
+            ex['include'] = [col['colname'] for col in res['rows']]
+
+    return True, result['rows']
+
+
+@get_template_path
+def get_exclusion_constraint_sql(conn, did, tid, data, template_path=None):
+    """
+    This function will return sql for exclusion constraints.
+    :param conn: Connection Object
+    :param did: Database ID
+    :param tid: Table ID
+    :param data: Data
+    :param template_path: Template Path
+    :return:
+    """
+
+    sql = []
+    # Check if constraint is in data
+    # If yes then we need to check for add/change/delete
+    if 'exclude_constraint' in data:
+        constraint = data['exclude_constraint']
+        # If constraint(s) is/are deleted
+        if 'deleted' in constraint:
+            for c in constraint['deleted']:
+                c['schema'] = data['schema']
+                c['table'] = data['name']
+
+                # Sql for drop
+                sql.append(
+                    render_template("/".join(
+                        [template_path, 'delete.sql']),
+                        data=c, conn=conn).strip("\n")
+                )
+
+        if 'changed' in constraint:
+            for c in constraint['changed']:
+                c['schema'] = data['schema']
+                c['table'] = data['name']
+
+                modified_sql, name = get_sql(conn, c, did, tid, c['oid'])
+                sql.append(modified_sql.strip('\n'))
+
+        if 'added' in constraint:
+            for c in constraint['added']:
+                c['schema'] = data['schema']
+                c['table'] = data['name']
+
+                add_sql, name = get_sql(conn, c, did, tid)
+                sql.append(add_sql.strip("\n"))
+
+    if len(sql) > 0:
+        # Join all the sql(s) as single string
+        return '\n\n'.join(sql)
+    else:
+        return None
+
+
+@get_template_path
+def get_sql(conn, data, did, tid, exid=None, template_path=None):
+    """
+    This function will generate sql from model data.
+    :param conn: Connection Object
+    :param data: data
+    :param did: Database ID
+    :param tid: Table id
+    :param exid: Exclusion Constraint ID
+    :param template_path: Template Path
+    :return:
+    """
+    name = data['name'] if 'name' in data else None
+    if exid is not None:
+        sql = render_template("/".join([template_path, 'properties.sql']),
+                              did=did, tid=tid, cid=exid)
+        status, res = conn.execute_dict(sql)
+        if not status:
+            raise Exception(res)
+
+        if len(res['rows']) == 0:
+            raise ObjectGone(
+                _('Could not find the exclusion constraint in the table.'))
+
+        old_data = res['rows'][0]
+        if 'name' not in data:
+            name = data['name'] = old_data['name']
+
+        sql = render_template("/".join([template_path, 'update.sql']),
+                              data=data, o_data=old_data)
+    else:
+        if 'columns' not in data:
+            return _('-- definition incomplete'), name
+        elif isinstance(data['columns'], list) and len(data['columns']) < 1:
+            return _('-- definition incomplete'), name
+
+        sql = render_template("/".join([template_path, 'create.sql']),
+                              data=data, conn=conn)
+
+    return sql, name
